Subject: Re: linux-next: Tree for Sep 20 (ppc32: ADB_CUDA Kconfig warning)

From: Michael Ellerman <[email-masked]>
Date: Fri, 22 Sep 2023 10:10:07 +1000

Randy Dunlap <[email-masked]> writes:
> On 9/19/23 20:37, Stephen Rothwell wrote:
>> Hi all,
>> 
>> Changes since 20230919:
>> 
>> The mm tree lost its boot warning.
>> 
>> The drm-misc tree gained a conflict against Linus' tree.
>> 
>> Non-merge commits (relative to Linus' tree): 6006
>>  3996 files changed, 459968 insertions(+), 111742 deletions(-)
>> 
>> ----------------------------------------------------------------------------
>
> 4 out of 10 randconfigs have this warning:
>
> WARNING: unmet direct dependencies detected for ADB_CUDA
>   Depends on [n]: MACINTOSH_DRIVERS [=n] && (ADB [=n] || PPC_PMAC [=y]) && !PPC_PMAC64 [=n]
>   Selected by [y]:
>   - PPC_PMAC [=y] && PPC_BOOK3S [=y] && CPU_BIG_ENDIAN [=y] && POWER_RESET [=y] && PPC32 [=y]
>
> WARNING: unmet direct dependencies detected for ADB_CUDA
>   Depends on [n]: MACINTOSH_DRIVERS [=n] && (ADB [=n] || PPC_PMAC [=y]) && !PPC_PMAC64 [=n]
>   Selected by [y]:
>   - PPC_PMAC [=y] && PPC_BOOK3S [=y] && CPU_BIG_ENDIAN [=y] && POWER_RESET [=y] && PPC32 [=y]
>
> WARNING: unmet direct dependencies detected for ADB_CUDA
>   Depends on [n]: MACINTOSH_DRIVERS [=n] && (ADB [=n] || PPC_PMAC [=y]) && !PPC_PMAC64 [=n]
>   Selected by [y]:
>   - PPC_PMAC [=y] && PPC_BOOK3S [=y] && CPU_BIG_ENDIAN [=y] && POWER_RESET [=y] && PPC32 [=y]

Crud. Caused by:

a3ef2fef198c ("powerpc/32: Add dependencies of POWER_RESET for pmac32")

I was suspicious of that select, I should have been *more* suspicious :)

I think this is a fix. The PPC32 isn't needed because ADB depends on (PPC_PMAC && PPC32).

diff --git a/arch/powerpc/platforms/powermac/Kconfig b/arch/powerpc/platforms/powermac/Kconfig
index 8bdae0caf21e..84f101ec53a9 100644
--- a/arch/powerpc/platforms/powermac/Kconfig
+++ b/arch/powerpc/platforms/powermac/Kconfig
@@ -2,7 +2,7 @@
 config PPC_PMAC
        bool "Apple PowerMac based machines"
        depends on PPC_BOOK3S && CPU_BIG_ENDIAN
-       select ADB_CUDA if POWER_RESET && PPC32
+       select ADB_CUDA if POWER_RESET && ADB
        select MPIC
        select FORCE_PCI
        select PPC_INDIRECT_PCI if PPC32

cheers